IF 0  ; 
                      Build this template with "CONSOLE ASSEMBLE AND LINK"
ENDIF ; 

    include \masm32\include\masm32rt.inc

    Get_ID_String PROTO :DWORD
    get_processor PROTO :DWORD
    iType         PROTO :DWORD

    ITST STRUCT
      sse42 dd ?
      sse41 dd ?
      sse3  dd ?
      sse2  dd ?
      sse   dd ?
      mmx   dd ?
    ITST ENDS

    .code

start:
   
; 

    call main
    inkey
    exit

; 

main proc

    LOCAL pbuf  :DWORD                  ; pointer
    LOCAL buffer[128]:BYTE              ; buffer
    LOCAL itst  :ITST

    mov pbuf, ptr$(buffer)

    print "Manufacturer = "
    invoke Get_ID_String,pbuf
    print ltrim$(pbuf),13,10,13,10

    print "Model ID string = "
    invoke get_processor,pbuf
    print ltrim$(pbuf),13,10,13,10

    print "Supported Instruction Sets ",13,10

    invoke iType,ADDR itst

    .if itst.sse42 == 1
      print "SSE4.2 YES",13,10
    .else
      print "SSE4.2 NO",13,10
    .endif

    .if itst.sse41 == 1
      print "SSE4.1 YES",13,10
    .else
      print "SSE4.1 NO",13,10
    .endif

    .if itst.sse3 == 1
      print "SSE3   YES",13,10
    .else
      print "SSE3   NO",13,10
    .endif

    .if itst.sse2 == 1
      print "SSE2   YES",13,10
    .else
      print "SSE2   NO",13,10
    .endif

    .if itst.sse == 1
      print "SSE    YES",13,10
    .else
      print "SSE    NO",13,10
    .endif

    .if itst.mmx == 1
      print "MMX    YES",13,10
    .else
      print "MMX    NO",13,10
    .endif

    ret

main endp

; 

get_processor proc pBuffer:DWORD

    LOCAL basicinf  :DWORD
    LOCAL extended  :DWORD

    mov eax, 0                                  ; call basic info function
    cpuid
    mov basicinf, eax

    mov eax, 80000000h                          ; call extended info function
    cpuid
    mov extended, eax

    .if extended == 80000004h || extended == 80000008h
      jmp getID
    .endif

    .if basicinf == 00000001h
      cst pBuffer, "i486 or early Pentium Processor"
      ret
    .elseif basicinf == 00000002h
      cst pBuffer, "Pentium Pro, II or Celeron Processor"
      ret
    .elseif basicinf == 00000003h
      cst pBuffer, "Pentium III Processor"
      ret
    .else
      cst pBuffer, "Cannot Identify x86 Processor"
      ret
    .endif

  getID:

    push ebx
    push esi

    mov esi, pBuffer                    ; load buffer address into ESI
   
    mov eax, 80000002h                  ; extended function 2
    cpuid

    mov [esi],    eax                   ; write results to buffer
    mov [esi+4],  ebx
    mov [esi+8],  ecx
    mov [esi+12], edx

    mov eax, 80000003h                  ; extended function 3
    cpuid

    mov [esi+16], eax                   ; write results to buffer
    mov [esi+20], ebx
    mov [esi+24], ecx
    mov [esi+28], edx

    mov eax, 80000004h                  ; extended function 4
    cpuid

    mov [esi+32], eax                   ; write results to buffer
    mov [esi+36], ebx
    mov [esi+40], ecx
    mov [esi+44], edx

    mov [esi+48], DWORD PTR 0           ; terminate result

    pop esi
    pop ebx

    ret

get_processor endp

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

Get_ID_String proc pBuffer:DWORD

    push ebx
   
    mov eax, 0                          ; set ID string for Intel
    cpuid

    mov eax, [esp+4][4]                 ; (pBuffer) load buffer address into ESI

    mov [eax],    ebx                   ; write results to buffer
    mov [eax+4],  edx
    mov [eax+8],  ecx
    mov [eax+12], DWORD PTR 0           ; terminate result

    pop ebx
   
    ret 4

Get_ID_String endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

iType proc pStruct:DWORD

    LOCAL ecx_  :DWORD
    LOCAL edx_  :DWORD
    LOCAL rval  :DWORD

    push esi
    mov esi, pStruct

    mov eax, 1
    cpuid

    mov ecx_, ecx                                   ; store ECX results in variable
    mov edx_, edx                                   ; store EDX results in variable

  ; bit 20 ecx = sse4.2       6
  ; bit 19 ecx = sse4.1       5
  ; bit  0 ecx = sse3         4

    mov eax, ecx_
    and eax, 00000000000100000000000000000000b      ; test bit 20
    ror eax, 20
    .if eax == 1
      mov (ITST PTR [esi]).sse42, 1
    .else
      mov (ITST PTR [esi]).sse42, 0
    .endif

    mov eax, ecx_
    and eax, 00000000000010000000000000000000b      ; test bit 19
    ror eax, 19
    .if eax == 1
      mov (ITST PTR [esi]).sse41, 1
    .else
      mov (ITST PTR [esi]).sse41, 0
    .endif

    mov eax, ecx_
    and eax, 00000000000000000000000000000001b      ; test bit 0

    .if eax == 1
      mov (ITST PTR [esi]).sse3, 1
    .else
      mov (ITST PTR [esi]).sse3, 0
    .endif

  ; bit 26 edx = sse2         3
  ; bit 25 edx = sse          2
  ; bit 23 edx = mmx          1

    mov eax, edx_
    and eax, 00000100000000000000000000000000b      ; test bit 26
    ror eax, 26
    .if eax == 1
      mov (ITST PTR [esi]).sse2, 1
    .else
      mov (ITST PTR [esi]).sse2, 0
    .endif

    mov eax, edx_
    and eax, 00000010000000000000000000000000b      ; test bit 25
    ror eax, 25
    .if eax == 1
      mov (ITST PTR [esi]).sse, 1
    .else
      mov (ITST PTR [esi]).sse, 0
    .endif

    mov eax, edx_
    and eax, 00000000100000000000000000000000b      ; test bit 23
    ror eax, 23
    .if eax == 1
      mov (ITST PTR [esi]).mmx, 1
    .else
      mov (ITST PTR [esi]).mmx, 0
    .endif

    pop esi

    ret

iType endp

; 

end start
